%!TeX root=../tese.tex
%("dica" para o editor de texto: este arquivo é parte de um documento maior)
% para saber mais: https://tex.stackexchange.com/q/78101/183146

%% ------------------------------------------------------------------------- %%
\chapter{Introdution}
\label{cap:introdution}
With the growth in the urban center population, mainly in developing countries, a mismatch in the management of their resources to meet citizens' needs has come up. The Brazilian city of São Paulo is a good example of this, it is the most populous municipality of the country \citep{IBGE:2019}.
On the other hand, the constant advancement in computing technologies may provide tools to support information analysis in the cities and contribute to local public management.
This use of technology is what defines the so-called smart cities.

Smart cities aim at improving urban efficiency and quality of life, contributing to the city's sustainability, mobility, health, accessibility, and so on.
The Institute of Mathematics and Statistics of the University of São Paulo (IME-USP) hosts the National Institute of Science and Technology (INCT) for the Future Internet and Smart Cities -- the InterSCity project \footnote{http://interscity.org} -- to investigate strategies and create applications to promote the technological innovation in the country.
The project in question in this paper is one of the projects supported by InterSCity.

In the context of health, there is a growth in generated and stored data from health facilities.
A large body of data can provide relevant information that can be used by public managers to benefit the creation of public policies.
The World Health Organization (WHO) advises countries to develop responsive and resilient health systems that create evidence-based policies as one of its results.\footnote{https://www.who.int/healthsystems/about/progress-challenges/en/}
So, the collection and processing of health data become fundamental for obtaining the evidences to create evidence-based policies.

\section{Motivation}
\label{sec:motivation}
It can be a difficult task to analyze a large body of data because of its size and complexity.
In this project, we worked in collaboration with the São Paulo Municipal Health Secretariat (SMS-SP) to develop a platform for large scale data processing.
It enables the analysis of health data via advanced techniques for data visualization.
This platform intends to be a useful tool which, in term, may help the elaboration and management of public health policies.

The purpose of the platform is to analyze the Hospital Information System datasets (SIH-SUS), provided by the Brazilian National Health System (SUS).
These datasets contains hospitalization information such as the patient diagnosis, the hospital location, the geo-anonymized (see Section \ref{sec:final_architecture}) patient location, and so on.
So, the platform also deals with many georeferenced data that would be visualized on a dynamic map.

There were a previous project, developed by IME-USP undergraduate students, that aimed to resolve the same situation using the São Paulo SIH-SUS dataset.
However, this previous project resulted in a unsatisfactory performance and a non generalizable system, i.e. the developed system was attached to the São Paulo SIH-SUS dataset, not allowing the use of SIH-SUS datasets from other regions of Brazil.

The platform we propose aims to deal with any SIH-SUS dataset.
The platform also faces the performance problem by refactoring the previous system and implementing a new software architecture called \textit{Model-View-Controller} (MVC).

To achieve this goal, we studied the possibility to use \textit{Microservices} as a solution to the problems presented above.
Nevertheless, the use of the \textit{Microservices} technologies would not be a good solution to our case because we could not implement and maintain these technologies (Section \ref{sec:architecture_evolution} describes this better).
Finally, we found a better to implement and maintain way to face the problems using the MVC software pattern.
It brought performance benefits over the previous project, and also enabled the possibility to use other SIH-SUS datasets beyond the São Paulo dataset.

\section{Methods}
\label{sec:methods}
As mentioned previously, this project had the collaboration of SMS-SP.
The collaboration between government and academia is often challenging, and its main cause is the poor project management \citep{Anthopoulos:2016}.
According to \citet{Wen:2019}, when in collaboration, government and academia should strive to increase the chances of success.
Successful government-academia collaborations need to mitigate interinstitutional conflicts.
The adoption of practices from agile methods and FLOSS ecosystems impact the people involved in the project notably \citep{Wen:2019}.

The contact between IME-USP and SMS-SP exists since the development of the previous platform.
Since then, there are two SMP-SP agents keeping in touch with us.
They receive the notifications of advances and difficulties we are handling, and we receive their feedback.
In our case, the use of practices from agile methods improved the communication between us and SMS-SP agents.
We are used to communicate through email, but we also had some important presential meetings along the year.

The use of the agile methods, such as: the presential meetings with SMS-SP, the development iterations, the use of Kanban, and so on, helped us to detail the platform features and limits.
For example, through these meetings we knew the available resources at SMS-SP to implement and maintain the platform in development.
It helped us to define the better architecture to fit their needs and their available resources.


\section{Organization}

The capstone project is organized as follows. In Chapter \ref{cap:clustering}, we discuss the clustering method as a well know big data analysis technique used to facilitate the comprehension and visualization of large datasets, such as the São Paulo SIH-SUS dataset.
Chapter \ref{cap:dataset} describes the hospitalization dataset we are dealing with (the Hospital Information System; SIH-SUS), the Brazilian National Health System (SUS), the dataset creation, its structure, and how we structured this dataset on the platform database.
Chapter \ref{cap:platform} presents the aspects of the previous platform, the \textit{Microservices} pros and cons in our case, the final platform, its usage, its features, and the used design principles along the platform development.
Finally, we discuss the lessons learned, implications and future works to the platform in Chapter \ref{cap:discussion}.
